#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
 
#define MAX_ROWPIX 10000   
 
#define ROWLEN_12 ((MAX_ROWPIX*12)/8)
#define ROWLEN_10 ((MAX_ROWPIX*10)/8)
#define OUT_FILE_NAME  "out.crw"
 
int main(int argc, char **argv)
{
    FILE *rawin=NULL, *rawout=NULL;
    unsigned char rawrow12[ROWLEN_12];
    unsigned char rawrow10[ROWLEN_10];
    unsigned short row[MAX_ROWPIX];
    unsigned int rowpix, rows, rowlen_12, rowlen_10;
    struct stat info;
 
    unsigned int nrow,i,src;
 
        if (argc==1) {
            printf("filename expected"); 
            return 1;
        }


        rawin=fopen(argv[1],"r+b");
        rawout=fopen(OUT_FILE_NAME,"w+b");
 
        if (!rawin || !rawout) {
            printf("error 1"); 
            return 1;
        }

        if (stat(argv[1],&info)!=0) { printf("file not exist\n"); return 2;}

        switch (info.st_size){
         case (3720*2772*12)/8: rowpix=3720; rows=2772;  break; // another 10 MP with 12 bit RAW
         case (4480*3348*12)/8: rowpix=4480; rows=3348;  break; // 14.7 MP with 12 bit RAW

         default: printf("file is unknown\n"); return 3;
        }

        rowlen_12=(rowpix*12)/8;
        rowlen_10=(rowpix*10)/8;

 
        printf("processing %s", argv[1]);

        for (nrow=0; nrow<rows; nrow++) {

            fread(rawrow12, 1, rowlen_12, rawin);
        
            for (src=0, i=0; i<rowpix; src+=6, i+=4) {
                row[i+0]=((0xFF0&(((unsigned short)rawrow12[src+1])<<4)) | (rawrow12[src+0] >> 4)) >>2;
                row[i+1]=((0xF00&(((unsigned short)rawrow12[src+0])<<8)) | (rawrow12[src+3]     )) >>2;
                row[i+2]=((0xFF0&(((unsigned short)rawrow12[src+2])<<4)) | (rawrow12[src+5] >> 4)) >>2;
                row[i+3]=((0xF00&(((unsigned short)rawrow12[src+5])<<8)) | (rawrow12[src+4]     )) >>2;
            }

            for (src=0, i=0; i<rowpix; src+=10, i+=8) {
              rawrow10[src+0]=(row[i+0]<<6)|(row[i+1]>>4);
              rawrow10[src+1]=(row[i+0]>>2);
              rawrow10[src+2]=(row[i+2]<<2)|(row[i+3]>>8);
              rawrow10[src+3]=(row[i+1]<<4)|(row[i+2]>>6);
              rawrow10[src+4]=(row[i+4]>>2);
              rawrow10[src+5]=(row[i+3]);
              rawrow10[src+6]=(row[i+5]<<4)|(row[i+6]>>6);
              rawrow10[src+7]=(row[i+4]<<6)|(row[i+5]>>4);
              rawrow10[src+8]=(row[i+7]);
              rawrow10[src+9]=(row[i+6]<<2)|(row[i+7]>>8);
           }
  
          fwrite(rawrow10, 1, rowlen_10, rawout);

        }
 
        fclose(rawin);
        fclose(rawout);
  
    return 0;
}

